<?php

namespace WebSocket\Application;

/**
 * Simple Echo WebSocket Application
 * 
 * @author Nico Kaiser <nico@kaiser.me>
 * @author Jérome Freyre <jerome.freyre@heig-vd.ch>
 */
class EchoApplication extends Application
{
	private $clients = array();

	public function onConnect($client) {
		$this->clients[] = $client;
	}

	public function onDisconnect($client) {
		$key = array_search($client, $this->clients);
		if ($key) {
			unset($this->clients[$key]);
		}
	}

	public function onData($data, $client) {
		// Create the object
		$obj = (object) null;
		$obj->who = $client->toString();
		$obj->msg = $data;

		// Send the object to all clients
		foreach ($this->clients as $sendto) {
			$sendto->send(json_encode($obj));
		}
	}
}